//----------------------------------------------------------------
// Bilinear Zooming Applet by Michael Kbel
//----------------------------------------------------------------
import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.image.PixelGrabber;
import java.util.Date;

// - check bitmap -> light dirty greyscale pixels in text -> use 256 greyscale gif !?
//
// * Attention: Zoomfactor and xy_offsets must correlate, otherwise out of image boundaries !!!
// * so -> radius and offsets for rnd xy's must be small enough !!!

public class bilizo extends Applet implements Runnable
{

        private Thread  T_bilizo = null;
        private String paramStr;

        private int max_pics,max_pixel,sleep_time,max_x,max_y,picture_max_x,picture_max_y;
	  private int pc_counter,pc_max,max_xy_steps,xy_step,u_max,v_max,x_off,y_off,dmu,dmv;
        private int x_off_array[],y_off_array[],ScreenPixel[],PicturePixel[],PictureGreys[][],Buffer0[][],Buffer1[][],Palette[][];
        private int pc_efct[],pc_timer[],pc_bmp[],pc_pal[],pc_xy[],pc_rf[],pc_cl[],algo[],ratio[];
        		  
        private Date time;
        private long timer_start,timer_current;  
        
        private Image TMPscreenScr,globalimagedata;
        private MemoryImageSource mis;
        private ColorModel cm=ColorModel.getRGBdefault();
        
        public void init()
        {
        	    max_pics	 =    1;	// number of pics in jpg
                sleep_time     =   50;	// thread sleep time init
                max_xy_steps   =   32;    // maximum amount of steps for x_off and y_off
                xy_step        =    0;    // init x_off and y_off step
                pc_counter	 =    0;    // global demo programm counter
                
                this.setBackground(Color.black);
                this.setForeground(Color.black);
                
                paramStr      = getParameter("max_pics");
                max_pics      = Integer.parseInt(paramStr);
                paramStr      = getParameter("thread_sleep");
                sleep_time    = Integer.parseInt(paramStr);

                paramStr = getParameter("max_w");
                max_x = Integer.parseInt(paramStr);
                paramStr = getParameter("max_h");
                max_y = Integer.parseInt(paramStr);
                max_pixel = max_x*max_y;

                MediaTracker tracker = new MediaTracker(this);
                globalimagedata = getImage( getDocumentBase(),"pics.jpg");
                tracker.addImage(globalimagedata, 0);
                try
                {
                        tracker.waitForID(0);
                }
                catch(Exception e) {};

                picture_max_x = globalimagedata.getWidth(this);
                picture_max_y = globalimagedata.getHeight(this);
                PicturePixel = new int[picture_max_x * picture_max_y];
                PictureGreys = new int[max_pics][picture_max_x * max_y];

                PixelGrabber grabber = new PixelGrabber(globalimagedata,0,0,picture_max_x,picture_max_y,PicturePixel,0,picture_max_x);
                boolean done = false;
                do
                {
                        try
                        {
                                done = grabber.grabPixels(0);
                        }
                        catch ( InterruptedException e ) {}
                }
                while( !done );

		    try
                {
                        tracker.waitForID(1);
                }
                catch(InterruptedException e) {}

                ScreenPixel 	= new int[max_pixel];
                Buffer0 	= new int[max_y][max_x];
                Buffer1 	= new int[max_y][max_x];
                Palette 	= new int[11][256];
                x_off_array 	= new int[max_xy_steps];
                y_off_array 	= new int[max_xy_steps];
                algo		= new int[12];
                ratio		= new int[12];
		
		    mis=new MemoryImageSource(max_x, max_y, cm, ScreenPixel, 0, max_x);
                mis.setAnimated(true);
                mis.setFullBufferUpdates(true);
                TMPscreenScr=createImage(mis);

		    // Set xy_offset algo and ratio data
		    // 4 Algorithms availabe and 3 ratios choosen
		    
		    algo[ 0]=1;ratio[ 0]=1;
		    algo[ 1]=2;ratio[ 1]=1;
		    algo[ 2]=3;ratio[ 2]=1;
		    algo[ 3]=4;ratio[ 3]=1;
		    algo[ 4]=1;ratio[ 4]=2;
		    algo[ 5]=2;ratio[ 5]=2;
		    algo[ 6]=3;ratio[ 6]=2;
		    algo[ 7]=4;ratio[ 7]=2;
		    algo[ 8]=1;ratio[ 8]=3;
		    algo[ 9]=2;ratio[ 9]=3;
		    algo[10]=3;ratio[10]=3;
		    algo[11]=4;ratio[11]=3;

	 	    // Create the programm data
	 	    
	 	    pc_max=56;				//maximum demo effect number	
	 	    
 	          pc_efct = new int[pc_max];	//[effect_number (0=bitmap, 1=lines, 0=nothing)]
        	    pc_timer= new int[pc_max];	//[timer in milliseconds]
        	    pc_bmp 	= new int[pc_max];	//[bitmap number]
        	    pc_pal	= new int[pc_max];	//[palette number]
        	    pc_xy	= new int[pc_max];	//[xy offset array to use]
        	    pc_rf	= new int[pc_max];    	//[zoom factor]
        	    pc_cl	= new int[pc_max];	//[cooling factor]
	         
	          pc_max=56;
	         
	          //pc_efct  0=bitmap, 1=lines, 2=bitmap+lines 3=nothing
                //pc_timer timer in milliseconds 
        	    //pc_bmp   depends on bitmap
        	    //pc_pal      0...grau
        	    //	      1...grn->wei
        	    //	      2...blau->orange->wei
        	    //	      3...rot->white
        	    //	      4...feuer
        	    //	      5...lila feuer
        	    //	      6...black->grey->black
        	    //	      7...rosa<->braun
        	    //	      8...volles spektrum
        	    //	      9...ozean
        	    //	     10...braun<->dunkelgrn
        	    		      
        	    //pc_xy    0-11 = circle and lissajou figures,
        	    //	     12 = totally random
        	    //	     13 = more stable random
        	    //	     14 = no offset change
        	    		     
        	    //pc_rf    0...100
        	    //pc_cl    0...255

	 	    pc_efct[ 0]=0;pc_timer[ 0]=6000;pc_bmp[ 0]= 0;pc_pal[ 0]= 4; pc_xy[ 0]=  0;pc_rf[ 0]=80;pc_cl[ 0]=50;	   	
	 	    pc_efct[ 1]=3;pc_timer[ 1]= 800;pc_bmp[ 1]= 0;pc_pal[ 1]= 4; pc_xy[ 1]=  0;pc_rf[ 1]=80;pc_cl[ 1]=50;	   	
	 	    pc_efct[ 2]=1;pc_timer[ 2]=1500;pc_bmp[ 2]= 0;pc_pal[ 2]= 6; pc_xy[ 2]=  0;pc_rf[ 2]=90;pc_cl[ 2]=10;	   	
	 	    pc_efct[ 3]=3;pc_timer[ 3]= 800;pc_bmp[ 3]= 0;pc_pal[ 3]= 6; pc_xy[ 3]=  0;pc_rf[ 3]=90;pc_cl[ 3]=10;	   	
	 	    pc_efct[ 4]=0;pc_timer[ 4]=6000;pc_bmp[ 4]= 1;pc_pal[ 4]= 1; pc_xy[ 4]=  0;pc_rf[ 4]=95;pc_cl[ 4]=15;	   	
	 	    pc_efct[ 5]=3;pc_timer[ 5]= 800;pc_bmp[ 5]= 0;pc_pal[ 5]= 1; pc_xy[ 5]=  0;pc_rf[ 5]=90;pc_cl[ 5]=10;	   	
	 	    pc_efct[ 6]=1;pc_timer[ 6]=1500;pc_bmp[ 6]= 0;pc_pal[ 6]= 6; pc_xy[ 6]=  0;pc_rf[ 6]=90;pc_cl[ 6]=10;	   	
	 	    pc_efct[ 7]=3;pc_timer[ 7]= 800;pc_bmp[ 7]= 0;pc_pal[ 7]= 6; pc_xy[ 7]=  0;pc_rf[ 7]=90;pc_cl[ 7]=10;	   	
	 	    pc_efct[ 8]=0;pc_timer[ 8]=6000;pc_bmp[ 8]= 2;pc_pal[ 8]= 1; pc_xy[ 8]=  0;pc_rf[ 8]=95;pc_cl[ 8]=15;	   	
	 	    pc_efct[ 9]=3;pc_timer[ 9]= 800;pc_bmp[ 9]= 0;pc_pal[ 9]= 1; pc_xy[ 9]=  0;pc_rf[ 9]=90;pc_cl[ 9]=10;	   	
	 	    pc_efct[10]=1;pc_timer[10]=1500;pc_bmp[10]= 0;pc_pal[10]= 6; pc_xy[10]=  0;pc_rf[10]=90;pc_cl[10]=10;	   	
	 	    pc_efct[11]=3;pc_timer[11]= 800;pc_bmp[11]= 0;pc_pal[11]= 6; pc_xy[11]=  0;pc_rf[11]=90;pc_cl[11]=10;	   	
	 	    pc_efct[12]=0;pc_timer[12]=6000;pc_bmp[12]= 3;pc_pal[12]= 1; pc_xy[12]=  0;pc_rf[12]=95;pc_cl[12]=15;	   	
	 	    pc_efct[13]=3;pc_timer[13]= 800;pc_bmp[13]= 0;pc_pal[13]= 1; pc_xy[13]=  0;pc_rf[13]=90;pc_cl[13]=10;	   	
	 	    pc_efct[14]=1;pc_timer[14]=1500;pc_bmp[14]= 0;pc_pal[14]= 6; pc_xy[14]=  0;pc_rf[14]=90;pc_cl[14]=10;	   	
	 	    pc_efct[15]=3;pc_timer[15]= 800;pc_bmp[15]= 0;pc_pal[15]= 6; pc_xy[15]=  0;pc_rf[15]=90;pc_cl[15]=10;	   	
	 	    pc_efct[16]=0;pc_timer[16]=6000;pc_bmp[16]= 4;pc_pal[16]= 1; pc_xy[16]=  0;pc_rf[16]=95;pc_cl[16]=15;	   	
	 	    pc_efct[17]=3;pc_timer[17]= 800;pc_bmp[17]= 0;pc_pal[17]= 1; pc_xy[17]=  0;pc_rf[17]=90;pc_cl[17]=10;	   	
	 	    pc_efct[18]=1;pc_timer[18]=1500;pc_bmp[18]= 0;pc_pal[18]= 6; pc_xy[18]=  0;pc_rf[18]=90;pc_cl[18]=10;	   	
	 	    pc_efct[19]=3;pc_timer[19]= 800;pc_bmp[19]= 0;pc_pal[19]= 6; pc_xy[19]=  0;pc_rf[19]=90;pc_cl[19]=10;	   	
	 	    pc_efct[20]=0;pc_timer[20]=6000;pc_bmp[20]= 5;pc_pal[20]= 1; pc_xy[20]=  0;pc_rf[20]=95;pc_cl[20]=15;	   	
	 	    pc_efct[21]=3;pc_timer[21]= 800;pc_bmp[21]= 0;pc_pal[21]= 1; pc_xy[21]=  0;pc_rf[21]=90;pc_cl[21]=10;	   	
	 	    pc_efct[22]=1;pc_timer[22]=1500;pc_bmp[22]= 0;pc_pal[22]= 6; pc_xy[22]=  0;pc_rf[22]=90;pc_cl[22]=10;	   	
	 	    pc_efct[23]=3;pc_timer[23]= 800;pc_bmp[23]= 0;pc_pal[23]= 6; pc_xy[23]=  0;pc_rf[23]=90;pc_cl[23]=10;	   	
	 	    pc_efct[24]=0;pc_timer[24]=6000;pc_bmp[24]= 6;pc_pal[24]= 1; pc_xy[24]=  4;pc_rf[24]=95;pc_cl[24]=15;  	
	 	    pc_efct[25]=3;pc_timer[25]= 800;pc_bmp[25]= 0;pc_pal[25]= 1; pc_xy[25]=  0;pc_rf[25]=90;pc_cl[25]=10;	   	
	 	    pc_efct[26]=1;pc_timer[26]=1500;pc_bmp[26]= 0;pc_pal[26]= 6; pc_xy[26]=  0;pc_rf[26]=90;pc_cl[26]=10;	   	
	 	    pc_efct[27]=3;pc_timer[27]= 800;pc_bmp[27]= 0;pc_pal[27]= 6; pc_xy[27]=  0;pc_rf[27]=90;pc_cl[27]=10;	   	
	 	    pc_efct[28]=0;pc_timer[28]=6000;pc_bmp[28]= 7;pc_pal[28]= 1; pc_xy[28]=  0;pc_rf[28]=95;pc_cl[28]=15;	   	
	 	    pc_efct[29]=3;pc_timer[29]= 800;pc_bmp[29]= 0;pc_pal[29]= 1; pc_xy[29]=  0;pc_rf[29]=90;pc_cl[29]=10;	   	
	 	    pc_efct[30]=1;pc_timer[30]=1500;pc_bmp[30]= 0;pc_pal[30]= 6; pc_xy[30]=  0;pc_rf[30]=90;pc_cl[30]=10;	   	
	 	    pc_efct[31]=3;pc_timer[31]= 800;pc_bmp[31]= 0;pc_pal[31]= 6; pc_xy[31]=  0;pc_rf[31]=90;pc_cl[31]=10;	   	
	 	    pc_efct[32]=0;pc_timer[32]=6000;pc_bmp[32]= 8;pc_pal[32]= 1; pc_xy[32]=  0;pc_rf[32]=95;pc_cl[32]=15;	   	
	 	    pc_efct[33]=3;pc_timer[33]= 800;pc_bmp[33]= 0;pc_pal[33]= 1; pc_xy[33]=  0;pc_rf[33]=90;pc_cl[33]=10;	   	
	 	    pc_efct[34]=1;pc_timer[34]=1500;pc_bmp[34]= 0;pc_pal[34]= 6; pc_xy[34]=  0;pc_rf[34]=90;pc_cl[34]=10;	   	
	 	    pc_efct[35]=3;pc_timer[35]= 800;pc_bmp[35]= 0;pc_pal[35]= 6; pc_xy[35]=  0;pc_rf[35]=90;pc_cl[35]=10;	   	
	 	    pc_efct[36]=0;pc_timer[36]=6000;pc_bmp[36]= 9;pc_pal[36]= 1; pc_xy[36]=  0;pc_rf[36]=95;pc_cl[36]=15;	   	
	 	    pc_efct[37]=3;pc_timer[37]= 800;pc_bmp[37]= 0;pc_pal[37]= 1; pc_xy[37]=  0;pc_rf[37]=90;pc_cl[37]=10;	   	
	 	    pc_efct[38]=1;pc_timer[38]=2000;pc_bmp[38]= 0;pc_pal[38]= 6; pc_xy[38]=  0;pc_rf[38]=90;pc_cl[38]=10;	   	
	 	    pc_efct[39]=3;pc_timer[39]= 800;pc_bmp[39]= 0;pc_pal[39]= 6; pc_xy[39]=  0;pc_rf[39]=90;pc_cl[39]=10;	   	
	 	    pc_efct[40]=0;pc_timer[40]=6000;pc_bmp[40]=10;pc_pal[40]= 1; pc_xy[40]=  0;pc_rf[40]=95;pc_cl[40]=15;	   	
	 	    pc_efct[41]=3;pc_timer[41]= 800;pc_bmp[41]= 0;pc_pal[41]= 1; pc_xy[41]=  0;pc_rf[41]=90;pc_cl[41]=10;	   	
	 	    pc_efct[42]=1;pc_timer[42]=1500;pc_bmp[42]= 0;pc_pal[42]= 6; pc_xy[42]=  0;pc_rf[42]=90;pc_cl[42]=10;	   	
	 	    pc_efct[43]=3;pc_timer[43]= 800;pc_bmp[43]= 0;pc_pal[43]= 6; pc_xy[43]=  0;pc_rf[43]=90;pc_cl[43]=10;	   	
	 	    pc_efct[44]=0;pc_timer[44]=6000;pc_bmp[44]=11;pc_pal[44]= 4; pc_xy[44]=  0;pc_rf[44]=80;pc_cl[44]=50;	   	
	 	    pc_efct[45]=3;pc_timer[45]= 800;pc_bmp[45]= 0;pc_pal[45]= 4; pc_xy[45]=  0;pc_rf[45]=80;pc_cl[45]=50;	   	
	 	    pc_efct[46]=1;pc_timer[46]=1500;pc_bmp[46]= 0;pc_pal[46]= 6; pc_xy[46]=  0;pc_rf[46]=90;pc_cl[46]=10;	   	
	 	    pc_efct[47]=3;pc_timer[47]= 800;pc_bmp[47]= 0;pc_pal[47]= 6; pc_xy[47]=  0;pc_rf[47]=90;pc_cl[47]=10;	   	
	 	    pc_efct[48]=0;pc_timer[48]=6000;pc_bmp[48]=12;pc_pal[48]= 1; pc_xy[48]=  0;pc_rf[48]=95;pc_cl[48]=15;	   	
	 	    pc_efct[49]=3;pc_timer[49]= 800;pc_bmp[49]= 0;pc_pal[49]= 1; pc_xy[49]=  0;pc_rf[49]=90;pc_cl[49]=15;	   	
	 	    pc_efct[50]=1;pc_timer[50]=1500;pc_bmp[50]= 0;pc_pal[50]= 6; pc_xy[50]=  0;pc_rf[50]=90;pc_cl[50]=10;	   	
	 	    pc_efct[51]=3;pc_timer[51]= 800;pc_bmp[51]= 0;pc_pal[51]= 6; pc_xy[51]=  0;pc_rf[51]=90;pc_cl[51]=10;	   	
	 	    pc_efct[52]=0;pc_timer[52]=9000;pc_bmp[52]=13;pc_pal[52]= 4; pc_xy[52]=  0;pc_rf[52]=80;pc_cl[52]=50;	   	
	 	    pc_efct[53]=3;pc_timer[53]= 800;pc_bmp[53]= 0;pc_pal[53]= 4; pc_xy[53]=  0;pc_rf[53]=80;pc_cl[53]=50;	   	
	 	    pc_efct[54]=1;pc_timer[54]=1500;pc_bmp[54]= 0;pc_pal[54]= 6; pc_xy[54]=  0;pc_rf[54]=90;pc_cl[54]=10;	   	
	 	    pc_efct[55]=3;pc_timer[55]= 800;pc_bmp[55]= 0;pc_pal[55]= 6; pc_xy[55]=  0;pc_rf[55]=90;pc_cl[55]=10;	   	
	 
    		    // Prepare some data
		    
                CreateColorPalette();
                ClearScreenBuffers();
                AdaptPicture();
                CalculateXYOffsetArrays();

                System.gc(); 		
															
                // Init Timer
                
                time = new Date();
                timer_start = time.getTime();

        }

	  public void CalculateXYOffsetArrays()
	  {
          int x_off_init,y_off_init,index,j,i,fp=1<<16,c;
          double t1,t2,w,radius,r_factor,ramp_div=2*Math.PI/max_xy_steps,phase=Math.PI/2;
          
          r_factor = (double)(pc_rf[pc_counter])/100;
		    
	    u_max = (int)((max_x<<16) * r_factor);  
	    v_max = (int)((max_y<<16) * r_factor);
		    
          x_off_init = ((max_x<<16)-u_max)/2 + 0;     // + 0 for center checking
          y_off_init = ((max_y<<16)-v_max)/2 + 0;
                
          dmu = u_max/max_x;
          dmv = v_max/max_y;
          
          c=pc_xy[pc_counter];
          
          if ((c>=0) && (c<12)) 
          {
     	    radius=4.0*fp;                             // radius * fp_factor
	    if (ratio[c]==2) phase=0;
	    for(i=0;i<max_xy_steps;i++)
    		{
    		 t1=Math.sin(i*ramp_div);
    		 t2=Math.sin(i*ramp_div*ratio[c]+phase);
    		 if (algo[c]==1) {t1=t1*radius;t2=t2*radius;}
    		 if (algo[c]==2) {t1=Math.sin(0.5*Math.PI*t1)*radius;t2=Math.sin(0.5*Math.PI*t2)*radius;}
    		 if (algo[c]==3) {t1=Math.sin(Math.PI*t1)*radius;t2=Math.sin(Math.PI*t2)*radius;}
    	 	 if (algo[c]==4) {t1=t1*t1*t1*radius;t2=t2*t2*t2*radius;}
             x_off_array[i] 	= x_off_init + (int)t1;  
             y_off_array[i]	= y_off_init + (int)t2;  
    	 	}
    	    }

          //	for(i=0;i<max_xy_steps;i++)
          //	{                     
	    //	t1  			= x_off_init + Math.sin(w*i)*m;
          //  	x_off_array[i] 	= (int)t1;  
          //  	t1  			= y_off_init + Math.cos(w*i)*m;
          //  	y_off_array[i]	= (int)t1;  
          //	} 	
          	
          if (c==12)
          {  
          	for(i=0;i<max_xy_steps;i++)
          	{                     
			t1  			= (Math.random()-0.5)*10*fp;
            	x_off_array[i] 	= x_off_init + (int)t1;  
            	t1  			= (Math.random()-0.5)*10*fp;
            	y_off_array[i]	= y_off_init + (int)t1;  
          	} 	
          }
          	
          if (c==13)
          { index=0; 
          	for(i=0;i<(max_xy_steps/8);i++)
          	{                     
		  	t1  		= (Math.random()-0.5)*10*fp;
              	t2  		= (Math.random()-0.5)*10*fp;
              	for(j=0;j<8;j++)
               	{	
                 		x_off_array[index] 	= x_off_init + (int)t1;  
                 		y_off_array[index++]	= y_off_init + (int)t2;  
          	   	}
          	} 	
          }
          
          if (c==14)
          {  
          	for(i=0;i<max_xy_steps;i++)
          	{                     
            	x_off_array[i] 	= x_off_init;  
            	y_off_array[i]	= y_off_init;  
          	} 	
          }
		
        }                      

        public void AdaptPicture()
        {
                int index_p=0,index_g;

		    for(int n=0;n<max_pics;n++)
		      {
		     	index_g=0; 
                  for(int y=0;y<max_y;y++)
                    for(int x=0;x<max_x;x++)
                      {
                       PictureGreys[n][index_g]=(((PicturePixel[index_p]&(255<<16))>>16)+((PicturePixel[index_p]&(255<<8))>>8)+(PicturePixel[index_p]&(255)))/3;
                       index_g++;
                       index_p++;
                      }
                  }   
                globalimagedata=null;
                PicturePixel=null;
        }

        public void update(Graphics g)
        {
                if (pc_efct[pc_counter]==0) PutBitmapInBuffer();
                if (pc_efct[pc_counter]==1) PutLinesInBuffer(5);
                if (pc_efct[pc_counter]==2) PutLinesAndBitmapInBuffer(5);
                if (pc_efct[pc_counter]==3) PutNothingInBuffer();
                
                BilinearZoom();
                
                mis.newPixels(0,0,max_x,max_y);
                g.drawImage(TMPscreenScr,0,0,this);
                
                //g.setColor(Color.white);
         	    //g.drawString("dmu   = "+dmu,10,10);
        }

        public boolean imageUpdate(Image image, int i1, int j1, int k, int i2, int j2)
        {
                return true;
        }

        public void start()
        {
                if (T_bilizo == null)
                {
                        T_bilizo = new Thread(this);
                        T_bilizo.start();
                }
        }

        public void stop()
        {
                if (T_bilizo != null)
                {
                        T_bilizo.stop();
                        T_bilizo = null;
                }
        }

        public void run()
        {
                while (true)
                {
                        try
                        {
                        	  //thread sleep
                        	 
					  T_bilizo.sleep(sleep_time);

                                //timer and effect control for the demo
                                                                
                                time = new Date();
                                timer_current = time.getTime();
                                
                                if ((timer_current-timer_start)>pc_timer[pc_counter])
                                	{
                                	 pc_counter++;
                                	 if (pc_counter==pc_max) pc_counter=0;
                                	 CalculateXYOffsetArrays();
                                	 timer_start=timer_current;
                                	}
					  
					  //xy_offset control
					  
                                x_off = x_off_array[xy_step];
                                y_off = y_off_array[xy_step];
                                xy_step++;
                                if (xy_step==max_xy_steps) xy_step=0;    
					  
					  //finally repaint the screen including all the calculations
					  
     	                          repaint();
				}
                        catch (InterruptedException e)
                        {
                                stop();
                        }
				
                }

        }

        public void ClearScreenBuffers()
        {
          for(int y=0;y<max_y;y++)
            for(int x=0;x<max_x;x++)
              {Buffer0[y][x]=0;Buffer1[y][x]=0;}
        }

	  public void PutBitmapInBuffer()
	  {
	    int index=0,temp,x,y;
	    
          //Put the bitmap in the buffer, dependant on old Buffer -> feedback effect
          
          for(y=0;y<max_y;y++)
            for(x=0;x<max_x;x++)
            {
          	  temp = PictureGreys[pc_bmp[pc_counter]][index++];
          	  if (temp>Buffer1[y][x]) {Buffer0[y][x]=temp;} else {Buffer0[y][x]=Buffer1[y][x];}
            }
        }  
        
	  public void PutNothingInBuffer()
	  {
	    int index=0,x,y;
	    
          //Dont put new pixels in the buffer, just copy it
          
          for(y=0;y<max_y;y++) for(x=0;x<max_x;x++) Buffer0[y][x]=Buffer1[y][x];
        }  
	
  	  public void PutLinesInBuffer(int lines)
	  {
	    int index=0,x,y;
	    
          //Dont lines in the buffer and copy it
                        
          DrawSomeLines(lines);
          for(y=0;y<max_y;y++) for(x=0;x<max_x;x++) Buffer0[y][x]=Buffer1[y][x];
        }  
  	  
  	  public void PutLinesAndBitmapInBuffer(int lines)
	  {
	    int index=0,temp,x,y;
	    
          //Put the bitmap and the lines in the buffer, dependant on old Buffer -> feedback effect
          
          DrawSomeLines(lines);

          for(y=0;y<max_y;y++)
            for(x=0;x<max_x;x++)
            {
          	  temp = PictureGreys[pc_bmp[pc_counter]][index++];
          	  if (temp>Buffer1[y][x]) {Buffer0[y][x]=temp;} else {Buffer0[y][x]=Buffer1[y][x];}
            }
        }  
	    		
        public void BilinearZoom()
        {
          int index=0,temp,x,y,u,v,iu,iu1,iv,iv1,fu,fv,fuv,texel_1,texel_2,texel_3,texel_4,texel,stexel;
                            
          //Bilinear zooming algorithm with fixed point math
      
          for(y=0;y<max_y;y++)
          {
          	v   = y_off + y*dmv; 
          	iv  = (v>>16)<<16;          // = int(v) for fixed point
          	fv  = v - iv;
          	iv  = iv>>16;               // back to buffer coord

    	           if (iv<0) iv=0;
                 if (iv>(max_y-2)) iv=max_y-2;
          	
          	iv1 = iv + 1;               // saves two adds in x_loop                      	
          	temp = (1<<16) - fv;        // saves one sub in x_loop           	
          	          	
            for(x=0;x<max_x;x++)
            {
		   u  = x_off + x*dmu;
               iu = (u>>16)<<16;        // = int(u) for fixed point  
               fu = u - iu;
               iu = iu>>16;             // back to buffer coord

                   if (iu<0) iu=0;
                   if (iu>(max_x-2)) iu=max_x-2;
               
               iu1 = iu + 1;            // saves one add in x_loop                      
                
               fuv = (fu>>8)*(fv>>8);   // (fu*fv)>>16 doesn't seem to work -> overflow
      
      	   texel_1 = Buffer0[iv ][iu ];
      	   texel_2 = Buffer0[iv ][iu1];
      	   texel_3 = Buffer0[iv1][iu ];
      	   texel_4 = Buffer0[iv1][iu1];
      	   
      	   texel = (texel_1*(temp-fu+fuv) + texel_2*(fu-fuv) + texel_3*(fv-fuv) + texel_4*fuv)>>16;
   	         texel  = texel-pc_cl[pc_counter];
      	   if (texel<0) texel = 0; 
      	   if (texel==0) {stexel=0;} else {stexel=texel+pc_cl[pc_counter];}
      	   
      	     if (texel>255) texel = 255;
      	     if (stexel>255) stexel =255;
      	   
      	   Buffer1[y][x]=texel;
      	   ScreenPixel[index++]= Palette[pc_pal[pc_counter]][stexel]; //+texel_sub for full white presence
       	}
          }
        }

        public void CreateColorPalette()
        {
        	    int r,g,b,i,j,index,pal_counter=0,alpha=255<<24;
        	    double f;
                
                //Greyscale
                for(i=0;i<256;i++) Palette[pal_counter][i] = (alpha) | (i<<16) | (i<<8) | i;
                pal_counter++;
                
                //Acorn Bilizo Palette
                r=255;g=255;b=255;index=255;
                for(i=0;i<256;i++)
                  {	
                   Palette[pal_counter][index] = (alpha) | (r<<16) | (g<<8) | b;
                   if (index>170) {r-=3;b-=3;}
                   g-=1;index--;
                  }
                pal_counter++;

		    //Acorn AudioBump Palette 1
		    f=255.0/112.0;
                for(i=0;i<113;i++)
                  {
                   b=(int)(i*f);
                   Palette[pal_counter][i] = (alpha) | b;
                  }
                for(i=113;i<226;i++)
                  {
                   r=(int)((i-113)*f*2);
                   g=(int)((i-113)*f/2.0);
                   b=(int)(253-(i-113)*f);
                   if (b<0) b=0; if(r>255) r=255;
                   Palette[pal_counter][i] = (alpha) | (r<<16) | (g<<8) | b;
                  }
                for(i=225;i<256;i++)
                  {
                   g=(int)(127+(i-225)*4.25);
                   b=(int)((i-225)*8.5);
                   Palette[pal_counter][i] = (alpha) | (255<<16) | (g<<8) | b;
                  }
                pal_counter++;
                
                //Acorn Bilizo Palette red 
                
                r=255;g=255;b=255;index=255;
                for(i=0;i<256;i++)
                  {	
                   Palette[pal_counter][index] = (alpha) | (r<<16) | (g<<8) | b;
                   if (index>170) {g-=3;b-=3;}
                   r-=1;index--;
                  }
                pal_counter++;
               
		    //Audio Fire Palette 0
		    for(i=0;i<51;i++) 
		      {
                   r=(int)(i*5.1);g=0;b=0;
                   Palette[pal_counter][i] = (alpha) | (r<<16) | (g<<8) | b;
                  }
                for(i=51;i<111;i++)
                  {
                   g=(int)((i-51)*4.322);
                   Palette[pal_counter][i] = (alpha) | (255<<16) | (g<<8);
                  }
                for(i=111;i<256;i++)
                  {
                   b=(int)((i-111)*1.771);
                   Palette[pal_counter][i] = (alpha) | (255<<16) | (255<<8) | b;
                  }
                pal_counter++;

		   //Audio Fire Palette 1      
		    for(i=0;i<26;i++)
		      {
                   r=(int)(i*10.2);
                   Palette[pal_counter][i] = (alpha) | (r<<16);
                  }
                for(i=26;i<111;i++)
                  {
                   g=(int)((i-26)*3.036);
                   Palette[pal_counter][i] = (alpha) | (255<<16) | (g<<8) | 255;
                  }
                for(i=111;i<256;i++)
                  {
                   b=(int)((i-111)*1.771);
                   Palette[pal_counter][i] = (alpha) | (255<<16) | (255<<8) | b;
                  }
                pal_counter++;

		   //Audio Fire Palette 2      
		    for(i=0;i<128;i++)
		      {
                   Palette[pal_counter][i] = (alpha) | ((i*2)<<16) | ((i*2)<<8) | (i*2);
                  }
                for(i=128;i<256;i++)
                  {
                   r=(255-i)*2;
                   Palette[pal_counter][i] = (alpha) | (r<<16) | (r<<8) | r;
                  }
                pal_counter++;
                               
       	   //Audio Fire Palette 8      
		    index=0;
		    for(i=0;i<8;i++)		     
		      {
		       g=(int)(7.75*i);b=(int)(16.375*i); 	 	
                   Palette[pal_counter][index++] = (alpha) | (g<<8) | b;
                  }
		    for(i=1;i<63;i++)		     
		      {
		       r=(int)(124-((63-i)*2));g=(int)(186-((63-i)*2));b=(int)(255-((63-i)*2)); 	 	 	 
                   Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;
                  }
		    for(i=1;i<63;i++)		     
		      {
		       r=(int)(255-((63-i)*2));g=(int)(186-((63-i)*2));b=g; 	 	 	 
                   Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;
                  }
		    for(i=1;i<63;i++)		     
		      {
		       r=(int)(124-((63-i)*2));g=(int)(186-((63-i)*2));b=(int)(255-((63-i)*2)); 	 	 	 
                   Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;
                  }
		    for(i=1;i<63;i++)		     
		      {
		       r=(int)(255-((63-i)*2));g=(int)(186-((63-i)*2));b=g; 	 	 	 
                   Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;
                  }
                pal_counter++;
                             
 		    
	  	  //Audio Fire Palette 12
	  	   index=0;
               for(i=0;i<32;i++) {r=(int)(i*8.225);g=0;b=0; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
               for(i=0;i<32;i++) {g=(int)(i*8.225);r=255;b=0; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
               for(i=0;i<32;i++) {r=(int)(255-i*8.225);g=255;b=0; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
               for(i=0;i<32;i++) {b=(int)(i*8.225);r=0;g=255; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
               for(i=0;i<32;i++) {g=(int)(255-i*8.225);r=0;b=255; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
               for(i=0;i<32;i++) {r=(int)(i*8.225);g=0;b=255; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
               for(i=0;i<32;i++) {b=(int)(255-i*8.225);r=255;g=0; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
               for(i=0;i<32;i++) {g=(int)(i*8.225);b=g;r=255; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
               pal_counter++;

    	  	  //Audio Fire Palette 13
	  	   index=0; 
               for(j=0;j<2;j++)
		    {
           		for(i=0;i<32;i++) {r=(int)(255-i*8.225);g=(int)(255-i*3.225);b=g; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
       		for(i=0;i<32;i++) {r=(int)(4+i*4.258);g=(int)(156+i*1.161);b=(int)(156+i*3.096); Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
       		for(i=0;i<32;i++) {r=(int)(132-i*4.258);g=(int)(196-i*2.064);b=(int)(248-i*8); Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
       		for(i=0;i<32;i++) {r=(int)(4+i*244/31);g=(int)(136+i*112/31);b=g; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
 		    }
 		    for(i=0;i<32;i++) {r=0;g=5*i;b=5*i; Palette[pal_counter][i] = (alpha) | (r<<16) | (g<<8) | b;}
                pal_counter++;
                
    	  	  //Audio Fire Palette 14
    	  	  
	  	   index=0;
               for(i=0;i<4;i++)
		    {
           		for(j=0;j<16;j++) {r=68+j*8;g=68+j*8;b=j*8; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
       		for(j=0;j<16;j++) {r=r=164-j*8;g=164-j*8;b=120-j*8; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
       		for(j=0;j<16;j++) {r=134+j*8;g=68+j*8;b=j*8; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
       		for(j=0;j<16;j++) {r=232-j*8;g=164-j*8;b=120-j*8; Palette[pal_counter][index++] = (alpha) | (r<<16) | (g<<8) | b;}
 		    }
 		    for(i=0;i<16;i++) {r=11*i;g=r;b=8*i; Palette[pal_counter][i] = (alpha) | (r<<16) | (g<<8) | b;}
                pal_counter++;

        }

	  public void DrawSomeLines(int n)
	  {
	  	   int i,x1,y1,x2,y2;
	  	   
	  	   for(i=0;i<n;i++)
	  	     {
	  	     	x1=10+(int)(Math.random()*(max_x-20));
	  	     	y1=10+(int)(Math.random()*(max_y-20));
	  	     	x2=10+(int)(Math.random()*(max_x-20));
	  	     	y2=10+(int)(Math.random()*(max_y-20));
	  	     	BresenhamLine(x1,y1,x2,y2,250);
	  	     	
	  	     }
	  }

    	  public void BresenhamLine(int x1,int y1,int x2,int y2,int colour)
        {
        	int x,y,a=2*(y2-y1),b=2*(x1-x2),D,xDirection=1,yDirection=1,bla;

        	if(x1>x2)	
        	{
                xDirection=-1;         //Linie in linkes im Koord.-...
                b=-b;                  //...System: Spiegeln an y-Achse
        	}

        	if(y1>y2)
        	{
                yDirection=-1;         //Linie in unten im Koord.-...
                a=-a;                  //...System: Spiegeln an x-Achse
        	}

        	D=2*a+b;
        	x=x1;                          //Startpunkt fuer Bresenham setzen
        	y=y1;                          

        if(a<-b)                 //Steigung<1, normaler Bresenham aus der Vorlesung 
        {
                while(x!=(x2+1))
                {
                        if(D<=0)
                                D=D+a;
                        else
                        {
                                D =D+a+b;
                                y+=yDirection;
                        }
                        Buffer1[y][x]=colour;
                        x+= xDirection;
                }
        }
        else                     //Steigung >=1
        {
                bla=-b;          //a und b vertauschen -> an der... 
                b  =-a;          //...Winkelhalbierenden spiegeln
                a  =bla;
                D  =2*a+b;       //und D neu berechnen
                
                for(;y!=(y2+1);y+=yDirection)   //Schleife ueber y, da y...
                {                               //...durch die Spiegelung die...
                                                //...repreaesentiert
                        if (D<=0) D=D+a;
                        else
                        {
                                D=D+a+b;
                                x+=xDirection;
                        }
                        Buffer1[y][x]=colour;
                }
        }
                        
    }


}